#!/usr/bin/python

# associates the packages that have strong deps > 3 * std deviation
# to their the popcon scores

# we should find out which percentage of the packages selected by
# this script are in the top 10% of the popcon

import optparse
import sys

import stats as st
import pstat as ps
import numpy as np

import operator

def load_table(fname):
    """return a list of tuples, one for each column in the input table"""

    l = []
    for line in open(fname):
        if line.startswith('#'):
            continue
        row = line.split()
        z = map(int, row[1:])
        l.append([row[0]] + z)
    return l


def main():

    usage = ""
    cmdline = optparse.OptionParser(usage=usage)
    (options, args) = cmdline.parse_args()

    stdev = 1476
    data = load_table(args[0])
    l = {}
    # considering strong dependencies
    # bigger then 2 * stdev
    for (k, d, s) in data :
        if s > 2 * stdev :
            l[k] = s
        
    popcon = load_table(args[1])
    l1 = []
    l2 = []
    d = []
    for (k, a, b, _,_,_) in popcon :
        # we consider the inst field of popcon
        if l.has_key(k) :
            d.append((k,l[k],a))
            l1.append(l[k])
            l2.append(a)

    for (k,a,b) in sorted(d,key=operator.itemgetter(1)) :
        print "%s \t sd = %s \t score = %s" % (k,a,b)

    rho = st.spearmanr(l1,l2)
    print rho

if __name__ == '__main__':
    main()

